/* MyOpenGLVideoView */

#import <Cocoa/Cocoa.h>
#import <QuickTime/QuickTime.h>
#include <OpenGL/gl.h>
#include <OpenGL/glu.h>
#include </sw/include/opencv/cv.h>
#include <stdlib.h>



@interface MyOpenGLVideoView : NSOpenGLView
{
	bool removeBackground;
	bool recordBackground;
	bool overlayYogi;
	bool bluescreening;

	//stuff for OpenGL-Display
	GLuint videoTexture;
	
	//Stuff for QuickTime
	NSTimer 			*gMyTimer;		// our timer for idling the sequence grabber
    
	SeqGrabComponent	gSeqGrab;		// the sequence grabber component
    SGChannel			gSGChanVideo;	// the sequence grabber channel component
	GWorldPtr			offScreen;		// Offscreen gworld used for decompression
	Rect				gBoundsRect;	// rect we are drawing into
	ImageSequence 		gDecomSeq;		// unique identifier for our decompression sequence
	
	//Stuff for OpenCV
	CvSize sourceSize;
	IplImage * source;
	IplImage * runningSource;
	IplImage * result;
	IplImage * work;
	IplImage * backgroundMean;
	IplImage * backgroundVariance3;
	int nrOfBackgroundImages;
	IplImage * backgroundSum;
	IplImage * backgroundSquaredSum;

	IplImage * backgroundImage;

	//"transfer OpenCV -> openGL
	CvSize glSize;
	IplImage * workGL;


	IBOutlet NSTextField * deNoise;
	IBOutlet NSTextField * alpha;
	IBOutlet NSTextField * threshold;
	IBOutlet NSImageView * background;
	
	float a;	
	
}
- (IBAction)toggleRecordingOfBackground:(id)sender;
- (IBAction)toggleBackgroundRemoval:(id)sender;
- (IBAction)toggleOverlay:(id)sender;
- (IBAction)toggleBluesceening:(id)sender;

- (id) initWithCoder: (NSCoder *) coder ;
- (void) initGLWindow ;
- (void) dealloc ;

//OpenGL stuff
- (void) updateImage:(char*)texture;
- (void) drawRect: (NSRect) bounds ;

//QT Stuff
-(void) sgIdleTimer:(id)sender;
-(OSErr) startGrab:(NSRect)grabRect;
-(void) endGrab;

//Access from Callback...
-(void)doImageProcessing;

-(GWorldPtr)gworld;
-(ImageSequence)decomSeq;
-(SGChannel)sgChanVideo;
-(Rect)boundsRect;

-(IplImage *)getSource;

@end

//lowest Level Callback for QT...
pascal OSErr mySGDataProc(SGChannel c, 
						  Ptr p,
						  long len,
						  long *offset,
						  long chRefCon,
						  TimeValue time,
						  short writeType, 
						  long refCon);
void saveOpenGLVideoViewObjectForCallback(void *theObject);


